/***文档注释***********************************************
 * 作者            ：
 * 创建日期     ：2018-05-07
 * 描述            ：交货地址配置表
 * 注意事项     ：
 * 遗留BUG   ：
 * 修改日期     ：
 * 修改人员     ：
 * 修改内容     ：
***********************************************************/
package market.Pms.Bs.impl;
import java.util.Date;
import java.util.List;

import market.Com.vo.CommonPage;
import market.Com.vo.ResultModel;
import market.Pms.Bs.mapper.PurBsDeliveryLocationMapper;
import market.Pms.Bs.service.PurBsDeliveryLocationService;
import market.Pms.Bs.vo.PurBsDeliveryLocation;

import org.springframework.transaction.annotation.Transactional;

import com.hnshituo.basic.service.impl.BaseServiceImpl;
import com.hnshituo.basic.service.support.PageModel;
import com.hnshituo.basic.spring.remoting.annotation.RemoteService;
import com.hnshituo.core.auth.service.HomeService;

@RemoteService(path="PurBsDeliveryLocationService")
public class PurBsDeliveryLocationServiceImpl extends BaseServiceImpl<PurBsDeliveryLocation,Object> implements PurBsDeliveryLocationService {
	/**
	 * 查询
	 * @param oci
	 * @return
	 */
	public ResultModel doQueryWeb(CommonPage<PurBsDeliveryLocation> oci){
		ResultModel rm=new ResultModel();
		PageModel<PurBsDeliveryLocation> pm=new PageModel<PurBsDeliveryLocation>(oci.getPageIndex(),oci.getPageSize());
		PurBsDeliveryLocation queryCls=oci.getObject()==null?(new PurBsDeliveryLocation()):oci.getObject();
		try{
			pm.setTotal(this.getMapper(PurBsDeliveryLocationMapper.class).doQueryCount(queryCls));
			pm.setRows(this.getMapper(PurBsDeliveryLocationMapper.class).doQuery(queryCls, (oci.getPageIndex()-1)*oci.getPageSize(), oci.getPageIndex()*oci.getPageSize()));
		
			rm.setData(pm);
			rm.setState("200");
		}catch(Exception ex){
			rm.setState("500");
			rm.setMsgInfo("错误："+ex.getMessage());
		}
		
		return rm;
	}
	
	/**
	 * 新增
	 * @param oci
	 * @return
	 */
	@Transactional(value="tm", rollbackFor=Exception.class)
	public ResultModel doAddWeb(CommonPage<PurBsDeliveryLocation> oci){
		ResultModel rm=new ResultModel();
		
		if(oci.getObjectList()==null||oci.getObjectList().size()==0){
			rm.setState("500");
			rm.setMsgInfo("请传入需操作的数据！");
			return rm;
		}
		
		for(PurBsDeliveryLocation pb:oci.getObjectList()){
			rm = ValidData(pb,"0");
			if("500".equals(rm.getState())){
				return rm;
			}
		}
		
		String userId = (String) this.getSession().getAttribute(HomeService.SESSION_USER_ID);
		String userName = (String) this.getSession().getAttribute(HomeService.SESSION_USER_NAME);
		
		int i=1;
		try{
			List<PurBsDeliveryLocation> queryClsList=this.getMapper(PurBsDeliveryLocationMapper.class).findWithCondition(null, " delivery_location_code like 'DZ%' ", " delivery_location_code desc ", 0, 1);
			if(queryClsList!=null&&queryClsList.size()>0){
				i=Integer.parseInt(queryClsList.get(0).getDelivery_location_code().substring(2))+1;
			}
		}catch(Exception ex){
			rm.setState("500");
			rm.setMsgInfo("新增失败："+ex.getMessage());
			return rm;
		}
		
		for(PurBsDeliveryLocation pb:oci.getObjectList()){
			pb.setDelivery_location_code("DZ"+String.format("%04d", i++));
			pb.setCreate_name(userName);
			pb.setCreate_userid(userId);
			pb.setCreate_time(new Date());
			this.getMapper(PurBsDeliveryLocationMapper.class).insert(pb);
		}
		
		rm.setState("200");
		return rm;
	}
	
	/**
	 * 修改,其中有效，无效则传编号跟状态即可
	 * @param oci 
	 * memo1 1正常修改  2则为有效无效处理
	 * @return
	 */
	public ResultModel doUpdateWeb(CommonPage<PurBsDeliveryLocation> oci){
		ResultModel rm=new ResultModel();
		String sType=("1".equals(oci.getMemo1())?"1":"");
		rm = ValidData(oci.getObject(),sType);
		if("500".equals(rm.getState())){
			return rm;
		}
		
		try{
			String userId = (String) this.getSession().getAttribute(HomeService.SESSION_USER_ID);
			String userName = (String) this.getSession().getAttribute(HomeService.SESSION_USER_NAME);
			
			if(!"1".equals(oci.getMemo1())){
				if("1".equals(oci.getObject().getValidflag())){//有效则作废数据制空
					this.getMapper(PurBsDeliveryLocationMapper.class).doUpdate(oci.getObject());
				}else{
					oci.getObject().setDelete_name(userName);
					oci.getObject().setDelete_userid(userId);
					oci.getObject().setDelete_time(new Date());
					this.getMapper(PurBsDeliveryLocationMapper.class).update(oci.getObject());
				}
			}else{
				oci.getObject().setUpdate_name(userName);
				oci.getObject().setUpdate_userid(userId);
				oci.getObject().setUpdate_time(new Date());
				this.getMapper(PurBsDeliveryLocationMapper.class).update(oci.getObject());
			}
			
			rm.setState("200");
		}catch(Exception ex){
			rm.setState("500");
			rm.setMsgInfo("修改失败："+ex.getMessage());
		}
		
		return rm;
	}
	
	
	
	
	/**
	 * 公共的数据验证，若需要其它的验证则继续增加
	 * @param oci
	 * @param sType 0新增  1修改
	 * @return
	 */
	public ResultModel ValidData(PurBsDeliveryLocation oci,String sType){
		ResultModel rm=new ResultModel();
		if(oci==null){
			rm.setState("500");
			rm.setMsgInfo("请传入需操作的数据！");
			return rm;
		}
		
		//需要验证数据是否出现重复的名称
		if(!"".equals(sType)){
			try{
				PurBsDeliveryLocation validCls=new PurBsDeliveryLocation();
				validCls.setDelivery_location(oci.getDelivery_location().trim());
				if("0".equals(sType)){
					ValidName(validCls);
				}else if("1".equals(sType)){
					//先获取是否存在被修改的数据
					PurBsDeliveryLocation pbd=this.getMapper(PurBsDeliveryLocationMapper.class).findById(oci.getDelivery_location_code());
					if(pbd!=null&&pbd.getDelivery_location_code()!=null){
						if(!oci.getDelivery_location().equals(pbd.getDelivery_location())){
							ValidName(validCls);
						}
					}else{
						rm.setState("500");
						rm.setMsgInfo("当前数据已被删除，无法修改！");
						return rm;
					}
				}
				
			}catch(Exception ex){
				rm.setState("500");
				rm.setMsgInfo("数据验证异常："+ex.getMessage());
				return rm;
			}
		}
		
		
		
		rm.setState("200");
		return rm;
	}
	/**
	 * 验证是否存在相同名称的数据
	 * @param oci
	 * @throws Exception
	 */
	public void ValidName(PurBsDeliveryLocation oci) throws Exception{
		int icount=this.getMapper(PurBsDeliveryLocationMapper.class).count(oci);
		if(icount>0){
			throw new Exception("已存在["+oci.getDelivery_location()+"]名称的数据!");
		}
	}
}
